/*********************************.FILE_HEADER.******************************
 *			.File:         . FormTCPSocketClient.h
 *			.Project Code: . LLC(Lambda LAN Card)
 *			.Author:       . Dinesh.K.M
 *          .Environment   . Microsoft Visual Studio 2005 C++ 
 *			.Created on:   . 30-Jan-2008
 *			.Copyright:    . Lambda
 *
 ****************************************************************************
 * .Type:			. Source File
 * .Description:	. Handles TCPSocket client application for LLC
 * .Code Status:	. Tested
 * .Reference:		. LLC_TCPClientSever_DetailDesign.doc
 * .Revision History: 
 * 
 ****************************************************************************/

#pragma once


namespace TCPSocketClient {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Net;
	using namespace System::Net::Sockets;
	using namespace System::Text;
	

	/// <summary>
	/// Summary for FormTCPSocketClient
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class FormTCPSocketClient : public System::Windows::Forms::Form
	{
	public:
		FormTCPSocketClient(void)
		{
			InitializeComponent();
			
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~FormTCPSocketClient()
		{
			if (components)
			{
				delete components;
			}
		}
	private: static const int PORT = 8003;
	private: static const int MAX_BUF_SIZE = 255;
	private: static const int RCV_TIME_OUT = 10000; // in milliseconds
	private: static const char QUESTION_MARK = '?';

	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::TextBox^  TextBoxIpAddress;


	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::TextBox^  TextBoxScpiCmd;
	private: System::Windows::Forms::Button^  ButtonRun;





	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::TextBox^  TextBoxResponse;


	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TextBox^  TextBoxStatus;

	private: System::Windows::Forms::Button^  ButtonQuit;
	

	protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->TextBoxIpAddress = (gcnew System::Windows::Forms::TextBox());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->TextBoxScpiCmd = (gcnew System::Windows::Forms::TextBox());
			this->ButtonRun = (gcnew System::Windows::Forms::Button());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->TextBoxResponse = (gcnew System::Windows::Forms::TextBox());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->TextBoxStatus = (gcnew System::Windows::Forms::TextBox());
			this->ButtonQuit = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"Verdana", 12.5F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(117, 27);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(278, 20);
			this->label1->TabIndex = 0;
			this->label1->Text = L"TCP Socket Sample Program";
			this->label1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(55, 63);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(315, 16);
			this->label2->TabIndex = 1;
			this->label2->Text = L"For the Lambda Genesys Power Supply Rev 01";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(53, 84);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(117, 16);
			this->label3->TabIndex = 2;
			this->label3->Text = L"with LAN option.";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(53, 111);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(195, 16);
			this->label4->TabIndex = 3;
			this->label4->Text = L"Using MS Visual Studio 2005";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(54, 140);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(355, 16);
			this->label5->TabIndex = 4;
			this->label5->Text = L"Enter the IP Address and a SCPI command or query.";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(52, 161);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(187, 16);
			this->label6->TabIndex = 5;
			this->label6->Text = L"Then click the RUN button.";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(132, 208);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(166, 16);
			this->label7->TabIndex = 6;
			this->label7->Text = L"IP Address or Hostname";
			// 
			// TextBoxIpAddress
			// 
			this->TextBoxIpAddress->Font = (gcnew System::Drawing::Font(L"Verdana", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->TextBoxIpAddress->Location = System::Drawing::Point(107, 232);
			this->TextBoxIpAddress->Name = L"TextBoxIpAddress";
			this->TextBoxIpAddress->Size = System::Drawing::Size(238, 27);
			this->TextBoxIpAddress->TabIndex = 0;
			this->TextBoxIpAddress->Text = L"169.254.1.1";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(129, 273);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(168, 16);
			this->label8->TabIndex = 8;
			this->label8->Text = L"SCPI command or Query";
			// 
			// TextBoxScpiCmd
			// 
			this->TextBoxScpiCmd->Font = (gcnew System::Drawing::Font(L"Verdana", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->TextBoxScpiCmd->Location = System::Drawing::Point(85, 294);
			this->TextBoxScpiCmd->Name = L"TextBoxScpiCmd";
			this->TextBoxScpiCmd->Size = System::Drawing::Size(294, 27);
			this->TextBoxScpiCmd->TabIndex = 1;
			this->TextBoxScpiCmd->Text = L"*IDN\?";
			// 
			// ButtonRun
			// 
			this->ButtonRun->Location = System::Drawing::Point(162, 341);
			this->ButtonRun->Name = L"ButtonRun";
			this->ButtonRun->Size = System::Drawing::Size(110, 30);
			this->ButtonRun->TabIndex = 2;
			this->ButtonRun->Text = L"RUN";
			this->ButtonRun->UseVisualStyleBackColor = true;
			this->ButtonRun->Click += gcnew System::EventHandler(this, &FormTCPSocketClient::ButtonRun_Click);
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(154, 390);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(114, 16);
			this->label9->TabIndex = 11;
			this->label9->Text = L"Query Response";
			// 
			// TextBoxResponse
			// 
			this->TextBoxResponse->Font = (gcnew System::Drawing::Font(L"Verdana", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->TextBoxResponse->Location = System::Drawing::Point(83, 415);
			this->TextBoxResponse->Multiline = true;
			this->TextBoxResponse->Name = L"TextBoxResponse";
			this->TextBoxResponse->ReadOnly = true;
			this->TextBoxResponse->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->TextBoxResponse->Size = System::Drawing::Size(284, 64);
			this->TextBoxResponse->TabIndex = 3;
			this->TextBoxResponse->Text = L"none";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(174, 489);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(52, 16);
			this->label10->TabIndex = 13;
			this->label10->Text = L"Status";
			// 
			// TextBoxStatus
			// 
			this->TextBoxStatus->Font = (gcnew System::Drawing::Font(L"Verdana", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->TextBoxStatus->Location = System::Drawing::Point(83, 512);
			this->TextBoxStatus->Multiline = true;
			this->TextBoxStatus->Name = L"TextBoxStatus";
			this->TextBoxStatus->ReadOnly = true;
			this->TextBoxStatus->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->TextBoxStatus->Size = System::Drawing::Size(284, 84);
			this->TextBoxStatus->TabIndex = 4;
			this->TextBoxStatus->Text = L"none";
			// 
			// ButtonQuit
			// 
			this->ButtonQuit->Location = System::Drawing::Point(162, 607);
			this->ButtonQuit->Name = L"ButtonQuit";
			this->ButtonQuit->Size = System::Drawing::Size(110, 30);
			this->ButtonQuit->TabIndex = 5;
			this->ButtonQuit->Text = L"QUIT";
			this->ButtonQuit->UseVisualStyleBackColor = true;
			this->ButtonQuit->Click += gcnew System::EventHandler(this, &FormTCPSocketClient::QUIT_Click);
			// 
			// FormTCPSocketClient
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(471, 669);
			this->Controls->Add(this->ButtonQuit);
			this->Controls->Add(this->TextBoxStatus);
			this->Controls->Add(this->label10);
			this->Controls->Add(this->TextBoxResponse);
			this->Controls->Add(this->label9);
			this->Controls->Add(this->ButtonRun);
			this->Controls->Add(this->TextBoxScpiCmd);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->TextBoxIpAddress);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Font = (gcnew System::Drawing::Font(L"Verdana", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->Margin = System::Windows::Forms::Padding(4);
			this->MaximizeBox = false;
			this->Name = L"FormTCPSocketClient";
			this->Text = L"TCPSocketClient";
			this->Load += gcnew System::EventHandler(this, &FormTCPSocketClient::FormTCPSocketClient_Load);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
/************************* FUNCTION HEADER ***********************************
 *	Function      : QUIT_Click
 *	Description   : This method is called when QUIT button clicked.
 *	Procedure     :	terminates form by calling Close(). 
 *	Return Value  : void
 *	Called by     : 
 *	Remarks       : 
 *
 ****************************************************************************/
private: System::Void QUIT_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			 Close();
		 }
/************************* FUNCTION HEADER ************************************
 *	Function      : ButtonRun_Click
 *	Description   : This method is called when RUN button clicked.
 *	Procedure     : create socket,estabish connection with server,send SCPI  
 *					command and receive the response.
 *	Return Value  : void
 *	Called by     : 
 *	Remarks       : 
 *
 *****************************************************************************/
private: System::Void ButtonRun_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 int nLength = 0;
			 Socket^ socket = nullptr;
			 try
			 {
				 TextBoxResponse->Text = "none";
				 TextBoxResponse->Update();
				 if(TextBoxIpAddress->Text == "")
				 {
					 TextBoxStatus->Text = "IP field is empty";
					 TextBoxStatus->Update();
					 return;
				 }
				 if(TextBoxScpiCmd->Text == "")
				 {
					 TextBoxStatus->Text = "SCPI command field is empty";
					 TextBoxStatus->Update();
					 return;
				 }
				 TextBoxStatus->Text = "Running";
				 TextBoxStatus->Update();

				 //Creating the socket
				 socket = gcnew Socket(AddressFamily::InterNetwork,
												SocketType::Stream,
												ProtocolType::Tcp);
				 socket->Blocking = true;
				 socket->ReceiveTimeout = RCV_TIME_OUT;
				 //Connecting 
				 socket->Connect(TextBoxIpAddress->Text,PORT); 
				 array<Byte>^ bySendBuffer = Encoding::ASCII->GetBytes(TextBoxScpiCmd->Text);
				 array<Byte>^ byRecvBuffer = gcnew array<Byte>(MAX_BUF_SIZE);
				 //Sending the command
				 socket->Send(bySendBuffer,bySendBuffer->Length,SocketFlags::None);
				 nLength = TextBoxScpiCmd->TextLength;
				  
				 // check SCPI command contains '?' character
				 if(QUESTION_MARK == bySendBuffer[nLength-1])
				 {
					//Receiving the response
					socket->Receive( byRecvBuffer, MAX_BUF_SIZE, SocketFlags::None);
					TextBoxResponse->Text = Encoding::ASCII->GetString(byRecvBuffer);
					TextBoxResponse->Update();
				 }
				 //Closing the socket
				 socket->Close();
				 TextBoxStatus->Text = "Success";
				 TextBoxStatus->Update();
			 }
			 catch(Exception^ Ex)
			 {
				 TextBoxResponse->Text = "none";
				 TextBoxResponse->Update();
				 TextBoxStatus->Text = Ex->Message;
				 TextBoxStatus->Update();
				 if(socket != nullptr)
				 {
					 //Closing the socket
					 socket->Close();
				 }
			 }
		 }
private: System::Void FormTCPSocketClient_Load(System::Object^  sender, System::EventArgs^  e) {
		 }
};
}

