/*********************************.FILE_HEADER.******************************
 *			.File:         . UDPSocketClientDlg.cpp
 *			.Project Code: . LLC(Lambda LAN Card)
 *			.Author:       . Princy.P.S
 *          .Environment   . Microsoft Visual Studio 6.0 C++ 
 *			.Created on:   . 11-Dec-2007
 *			.Copyright:    . Lambda
 *
 ****************************************************************************
 * .Type:			. Source File
 * .Description:	. Handles UDPclient application for LLC
 * .Code Status:	. Tested
 * .Reference:		. LLC_UDPClientSever_DetailDesign.doc
 * .Revision History: 
 * 
 ****************************************************************************/

#include "stdafx.h"
#include "UDPSocketClient.h"
#include "UDPSocketClientDlg.h"
#include <string.h>

#define   PORT            8005
#define	  ZERO		      0
#define	  MAX_SIZE	      255
#define   TIME_OUT_LIMIT  10000
#define	  NO_OF_DOTS	  3
#define   FIELD_LIM_LOW	  0
#define   FIELD_LIM_HIGH  255
#define   NO_OF_FIELDS    4
#define   END_OF_STRING	  '\0'
#define   DOT             '.'
#define   QUESTION_MARK   '?'
#define	  IDN_CMD         "*IDN?"
#define	  DEFAULT_IP      "169.254.1.1"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUDPSocketClientDlg dialog

CUDPSocketClientDlg::CUDPSocketClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUDPSocketClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUDPSocketClientDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUDPSocketClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUDPSocketClientDlg)
	DDX_Control(pDX, IDC_SCPI, m_EditScpiCmd);
	DDX_Control(pDX, IDC_STATUS, m_status);
	DDX_Control(pDX, IDC_RESPONSE, m_response);
	DDX_Control(pDX, IDC_IPADDRESS, m_ipAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUDPSocketClientDlg, CDialog)
	//{{AFX_MSG_MAP(CUDPSocketClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_RUN, OnRun)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUDPSocketClientDlg message handlers

BOOL CUDPSocketClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initializes a CFont object with the specified characteristics
	CFont cFont;
	cFont.CreateFont(0x14, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE,
				ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
				DEFAULT_QUALITY, DEFAULT_PITCH , "Verdana");
	// Set the heading font
	GetDlgItem(IDC_HEADING)->SetFont(&cFont);
	cFont.Detach();
	cFont.CreateFont(0x12, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
				ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
				DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Verdana");
	// Set the status, response, IP address & command field edit box font
	GetDlgItem(IDC_STATUS)->SetFont(&cFont);
	GetDlgItem(IDC_RESPONSE)->SetFont(&cFont);
	GetDlgItem(IDC_IPADDRESS)->SetFont(&cFont);
	GetDlgItem(IDC_SCPI)->SetFont(&cFont);
	// Delete the font object.
	cFont.Detach();
	
	// initialization
	UpdateData(TRUE);
	m_EditScpiCmd.SetWindowText(IDN_CMD);
	m_ipAddress.SetWindowText(DEFAULT_IP);
	m_status.SetWindowText("none");
	m_response.SetWindowText("none");
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUDPSocketClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUDPSocketClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUDPSocketClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/************************* FUNCTION HEADER ************************************
 *	Function      : OnRun
 *	Description   : run the dialog box.
 *	Procedure     : create socket,send SCPI command to the server
 *					 and receive the response.
 *	Return Value  : void
 *	Called by     : 
 *	Remarks       : 
 *
 *****************************************************************************/
void CUDPSocketClientDlg::OnRun() 
{
	int nRet = 0;
	char szErrMessage[MAX_SIZE] = {0};
	LPSTR lpErrMessage = {0};
	
	CString strScpiCmd = "";
	m_EditScpiCmd.GetWindowText(strScpiCmd);
	// check whether IP field and command field are filled
	CString strTemp = "";
	m_ipAddress.GetWindowText(strTemp);
	if(TRUE == strTemp.IsEmpty())
	{
		m_status.SetWindowText("IP field is empty");
		m_status.UpdateWindow();
		m_response.SetWindowText("none");
		m_response.UpdateWindow();
		return;
	}
	
	if(strScpiCmd.IsEmpty())
	{
		m_status.SetWindowText("SCPI command field is empty");
		m_status.UpdateWindow();
		m_response.SetWindowText("none");
		m_response.UpdateWindow();
		return;
	}

	m_status.SetWindowText("Running");
	m_status.UpdateWindow();
	m_response.SetWindowText("none");
	m_response.UpdateWindow();

	// Initialize Winsock
	WSADATA wsaData = {0};
	WORD wVersionRequested = 0;
	wVersionRequested = MAKEWORD(2, 2);
	nRet = WSAStartup(wVersionRequested, &wsaData);
	if(ZERO != nRet)
	{
		lpErrMessage = ErrorDescription();
		strcpy(szErrMessage, "WSA startup failed.");
		strcat(szErrMessage, lpErrMessage);
		m_status.SetWindowText(szErrMessage);
		m_status.UpdateWindow();
		return;
	}

	struct sockaddr_in serverAddr;
	struct hostent *pHostent = NULL;
	char szIpAddress[MAX_SIZE] = {0}; 
	bool blRet = 0;
	strncpy(szIpAddress, strTemp.GetBuffer(strTemp.GetLength()), MAX_SIZE);
	
	// Check whether IP address or Hostname and set the internet address
	if(isalpha(strTemp[ZERO]))
	{
		pHostent = gethostbyname(szIpAddress);
		if(NULL == pHostent) 
		{
			lpErrMessage=ErrorDescription();
			m_status.SetWindowText(lpErrMessage);
			m_status.UpdateWindow();
			WSACleanup();
			return;
		}
		else
		{
			serverAddr.sin_addr.s_addr = *((unsigned long*)
												pHostent->h_addr_list[ZERO]);
		}
	}
	else 
	{
		blRet = CheckIP(szIpAddress);
		if(FALSE == blRet)
		{
			m_status.SetWindowText("Invalid IP Address");
			m_status.UpdateWindow();
			WSACleanup();
			return;
		}
		else
		{
			serverAddr.sin_addr.s_addr = inet_addr(szIpAddress);
		}
	}

	/* The sockaddr_in structure specifies the address family,
	IP address, and port of the server to be connected to.*/
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(PORT);
	
	SOCKET connSock = 0;
	// create UDP SOCKET 
	connSock = socket(AF_INET, SOCK_DGRAM, ZERO);
	if(ZERO > connSock)
	{
		lpErrMessage = ErrorDescription();
		strcpy(szErrMessage, "Could not create socket.");
		strcat(szErrMessage, lpErrMessage);
		m_status.SetWindowText(szErrMessage);
		m_status.UpdateWindow();
		WSACleanup();
		return;
	}
	
	// set socket option
	struct timeval timeVal = {0};
	timeVal.tv_sec = TIME_OUT_LIMIT;  // in milliseconds 
	nRet = setsockopt(connSock, SOL_SOCKET, SO_RCVTIMEO, 
		                         (char *)&timeVal, sizeof(struct timeval));
	if(ZERO > nRet)
	{
		lpErrMessage = ErrorDescription();
		strcpy(szErrMessage, "Set socket option failed.");
		strcat(szErrMessage, lpErrMessage);
		m_status.SetWindowText(szErrMessage);
		m_status.UpdateWindow();
		Close_Sock(connSock);
		WSACleanup();
		return;
	}
	
	// send SCPI command to server
	int server_add_len=0;
	int nBufLength = 0;
	char szBuf[MAX_SIZE] = {0};
	UpdateData(TRUE);
	nBufLength = strScpiCmd.GetLength();
	strncpy(szBuf, strScpiCmd.GetBuffer(nBufLength), nBufLength);
	server_add_len=sizeof(serverAddr);
	nRet = sendto(connSock, szBuf, strlen(szBuf), ZERO, (struct sockaddr*)&serverAddr,
						server_add_len);
	if(ZERO >= nRet) 
	{
		lpErrMessage = ErrorDescription();
		strcpy(szErrMessage, "Could not send.");
		strcat(szErrMessage, lpErrMessage);
		m_status.SetWindowText(szErrMessage);
		m_status.UpdateWindow();
		Close_Sock(connSock);
		WSACleanup();
		return;
	}
	
	char szTemp[MAX_SIZE] = {0};
	char szReceiveBuf[MAX_SIZE] = {0};
	int nLength = 0;
	nLength = strScpiCmd.GetLength();
	strcpy(szTemp, strScpiCmd.GetBuffer(MAX_SIZE));
	
	// check SCPI command contains '?' character
	if(QUESTION_MARK == szTemp[nLength-1])
	{
		memset(szReceiveBuf, ZERO, sizeof(szReceiveBuf));
		// Receive response from server
		nRet = recvfrom(connSock, szReceiveBuf, MAX_SIZE, ZERO,
						(struct sockaddr*)&serverAddr, &server_add_len);
		if(ZERO >= nRet)
		{
			lpErrMessage = ErrorDescription();
			strcpy(szErrMessage, "Could not receive response.");
			strcat(szErrMessage, lpErrMessage);
			m_status.SetWindowText(szErrMessage);
			m_status.UpdateWindow();
			Close_Sock(connSock);
			WSACleanup();
			return;

		}
		else
		{
			m_response.SetWindowText(szReceiveBuf);
			m_response.UpdateWindow();
		}
	}
	
	Close_Sock(connSock);
	m_status.SetWindowText("Success");
	m_status.UpdateWindow();
	// cleanup
	WSACleanup();
	return;
}


/************************* FUNCTION HEADER ***********************************
 *	Function      : OnQuit
 *	Description   : terminates  modal dialog box 
 *	Procedure     :	terminates dialog box by calling EndDialog 
 *	Return Value  : void
 *	Called by     : 
 *	Remarks       : 
 *
 ****************************************************************************/
void CUDPSocketClientDlg::OnQuit() 
{
	OnCancel();
}


/************************* FUNCTION HEADER ************************************
 *	Function      : Close_Sock
 *	Description   : close the existing socket 
 *	Procedure     :	close socket by calling closesoket()
 *	Return Value  : void
 *	Called by     : 
 *	Remarks       : 
 *
 *****************************************************************************/
void CUDPSocketClientDlg::Close_Sock(SOCKET connSock)
{
	
	int nRet = 0;
	char szErrMessage[MAX_SIZE] = {0};
	LPSTR lpErrMessage = {0};
	nRet = closesocket(connSock);
	if(ZERO != nRet)
	{
		lpErrMessage = ErrorDescription();
		strcpy(szErrMessage, "Could not close socket.");
		strcat(szErrMessage, lpErrMessage);
		m_status.SetWindowText(szErrMessage);
		m_status.UpdateWindow();
	}
}


/************************* FUNCTION HEADER ************************************
 *	Function      : ErrorDescription
 *	Description   : Describes the last error
 *	Procedure     :	Done by calling GetLastError()
 *	Return Value  : Returns error message
 *	Called by     : 
 *	Remarks       : 
 *
 *****************************************************************************/
LPSTR CUDPSocketClientDlg::ErrorDescription()
{
	DWORD dwErrorCode = WSAGetLastError();
	LPTSTR lpMsgBuf = {0};
	DWORD dwResult = FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				dwErrorCode,
				ZERO, // Default language
				(LPTSTR) &lpMsgBuf,
				ZERO,
				NULL 
				);
	return lpMsgBuf;
}


/************************* FUNCTION HEADER ************************************
 *	Function      : CheckIpAddress
 *	Description   : check the IP address is valid
 *	Procedure     :	
 *	Return Value  : Return TRUE if success else FALSE
 *	Called by     : 
 *	Remarks       : 
 *
 *****************************************************************************/
 
bool CUDPSocketClientDlg::CheckIP(char szAddress[])
{
	int nFieldNum = 0;
    int nCount = 0;
    int nFieldCount = 0;
    int nLength = 0;
    int nDotsNum = 0;
	char szFieldArray[MAX_SIZE] = {0};
	int nAddressLength = strlen(szAddress);
	
    // For checking the number of dots in IP Address
	for(nCount = ZERO; nCount < nAddressLength; nCount++)
    {
		if(DOT == szAddress[nCount])
        {
			nDotsNum++;
        }
	}
    if( NO_OF_DOTS != nDotsNum )
    {
        return false;
    }

    // Checking each field in the IP Address with in the limit
	while(NO_OF_FIELDS > nFieldCount)
    {
		nCount=0;
		// Extracting each field by comparing with '.'
		while(szAddress[nLength]!= DOT && nLength < nAddressLength)
        {
			if(isdigit(szAddress[nLength]))
            {
				szFieldArray[nCount] = szAddress[nLength];
                nCount++;
                nLength++;
            }
            else
            {
                return false;
            }
        }
		szFieldArray[nCount] = END_OF_STRING;
        nFieldNum = atoi(szFieldArray);
		// Checking the boundary limits of each field
		if((FIELD_LIM_LOW <= nFieldNum) && (nFieldNum <= FIELD_LIM_HIGH))
        {
			nLength++;
            nFieldCount++;
        }
        else
        {
			return false;
        }
	}
    return true;
}


