/*********************************.FILE_HEADER.********************************
 *            .File:         . RpcPacktes.cs
 *            .Project Code: . LLC
 *            .Author:       . Shijoy.J.G
 *            .Environment:  . User Mode
 *            .Created on:   . 14-01-2008
 *            .Copyright:    . 2005 Lambda Americas.
 *
 ******************************************************************************
 * .Type:             .Source File
 * .Description:      .
 * .Code Status:      .Tested
 * .Reference:        .
 * .Revision History: .
 *
 *****************************************************************************/

namespace VXI_11_Discovery_Tool
{
    enum msg_type
    {
        CALL    = 0,
        REPLY   = 1
    };
    enum auth_flavor
    {
        AUTH_NULL   = 0,
        AUTH_UNIX   = 1,
        AUTH_SHORT  = 2,
        AUTH_DES    = 3
    };
    struct opaque_auth
    {
        public auth_flavor flavor;
        public uint length;
    };
    struct call_body
    {
        public uint rpcvers;
        public uint prog;
        public uint vers;
        public uint proc;
        public opaque_auth cred;
        public opaque_auth verf;
    };

    //RPC call packet structure
    struct RpcCallPacket
    {
        public uint xid;
        public uint type;
        public call_body cbody;
        public uint prgm;
        public uint vers;
        public uint proto;
        public uint port;
    };

    enum reply_stat
    {
        MSG_ACCEPTED = 0,
        MSG_DENIED = 1
    };
    enum accept_stat
    {
        SUCCESS         = 0, 
        PROG_UNAVAIL    = 1, 
        PROG_MISMATCH   = 2, 
        PROC_UNAVAIL    = 3, 
        GARBAGE_ARGS    = 4  
    };
    struct reply_body
    {
        public uint replystate;
        public opaque_auth verf;
        public uint acceptstate;
    };

    //RPC Reply packet structure
    struct RpcReplyPacket
    {
        public uint xid;
        public uint type;
        public reply_body rbody;
        public uint port;
    };
}